

/* All returned pointers are allocated with malloc().  Free with
   free(). */

char *
gnc_pref_name_get(SCM pref) {
  SCM func = gh_lookup("gnucash:pref-name-get");
  SCM scm_result;

  assert(func != SCM_UNDEFINED);

  result = gh_call1(func, pref);

  if(gh_vector_p(scm_result)) {
    char *c_result = gh_scm2newstr(result, NULL);
    return c_result;
  } else {
    return NULL;
  }
}

(define (gnucash:pref-name-get pref-data) (vector-ref pref-data 0))
(define (gnucash:pref-value-name-get pref-data) (vector-ref pref-data 1))
(define (gnucash:pref-type-get pref-data) (vector-ref pref-data 2))
(define (gnucash:pref-description-get pref-data) (vector-ref pref-data 3))

(define (gnucash:pref-arg-convert-func-get pref-data) (vector-ref pref-data 4))
(define (gnucash:pref-arg-verify-func-get pref-data) (vector-ref pref-data 5))
(define (gnucash:pref-default-get pref-data) (vector-ref pref-data 6))
(define (gnucash:pref-value-valid? pref-data) (vector-ref pref-data 7))
(define (gnucash:pref-value-get pref-data)
  (if (gnucash:pref-value-valid? pref-data)
      (vector-ref pref-data 8)
      (gnucash:pref-default-get pref-data)))

(define (gnucash:pref-value-set! pref-data value)
  (vector-set! pref-data 7 #t)
  (vector-set! pref-data 8 value))

(define (gnucash:pref-lookup-def pref)
  (assoc-ref gnucash:*prefs* pref))


SCM gnc_pref_lookup_def(const char *pref_name);

char *gnc_pref_name_get(SCM pref_data);
char *gnc_pref_value_name_get(SCM pref_data);
char *gnc_pref_type_get(SCM pref_data);
char *gnc_pref_description_get(SCM pref_data);

char * gnc_pref_string_value_get(SCM pref_data);
long gnc_pref_integer_value_get(SCM pref_data);
bool gnc_pref_boolean_value_get(SCM pref_data);

bool gnc_pref_string_value_set(SCM pref_data);
bool gnc_pref_integer_value_set(SCM pref_data);
bool gnc_pref_boolean_value_set(SCM pref_data);
